/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Tue, Oct 31, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
//#include "typedefine.h"
#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

#include "iodefine.h"

static int cnt = 0;
void LED(void){
    static int duty = 0;
    static int timer = 0;
    
	
    timer++;
    duty++;

    if(duty==10){
        duty=0;
    }
    if(timer==1000){
        timer=0;
	cnt++;
	switch(cnt){
		
		case 0:
			//1Oi
			PORTC.PODR.BIT.B5 =0 ;//Forward
			PORTC.PODR.BIT.B6 =0 ;//Forward
			MTU3.TGRC = 6297;
			MTU4.TGRC = 6297;
			MTU3.TGRB = 50;
			MTU4.TGRB = 50;
			break;
			
		case 1:
			//1Oi
			PORTC.PODR.BIT.B5 =0 ;//Forward
			PORTC.PODR.BIT.B6 =0 ;//Forward
			MTU3.TGRC = 6297;
			MTU4.TGRC = 6297;
			MTU3.TGRB = 50;
			MTU4.TGRB = 50;
			break;
		
		case 2:
			//1b~
			PORTC.PODR.BIT.B5 =0 ;//Forward
			PORTC.PODR.BIT.B6 =0 ;//Forward
			MTU3.TGRC = 6297;
			MTU4.TGRC = 6297;
			MTU3.TGRB = 6297;
			MTU4.TGRB = 6297;
			break;
			
		case 3:
			//90xEɐ
			PORTC.PODR.BIT.B5 =1 ;//Backward
			PORTC.PODR.BIT.B6 =0 ;//Forward
			MTU3.TGRC = 20714;
			MTU4.TGRC = 20714;
			MTU3.TGRB = 50;
			MTU4.TGRB = 50;
			break;
			
		case 4:
			//1b~
			PORTC.PODR.BIT.B5 =0 ;//Forward
			PORTC.PODR.BIT.B6 =0 ;//Forward
			MTU3.TGRC = 6297;
			MTU4.TGRC = 6297;
			MTU3.TGRB = 6297;
			MTU4.TGRB = 6297;
			break;
			
		case 5:
			//1Oi
			PORTC.PODR.BIT.B5 =0 ;//Forward
			PORTC.PODR.BIT.B6 =0 ;//Forward
			MTU3.TGRC = 6297;
			MTU4.TGRC = 6297;
			MTU3.TGRB = 50;
			MTU4.TGRB = 50;
			break;
			
		case 6:
			//1Oi
			PORTC.PODR.BIT.B5 =0 ;//Forward
			PORTC.PODR.BIT.B6 =0 ;//Forward
			MTU3.TGRC = 6297;
			MTU4.TGRC = 6297;
			MTU3.TGRB = 50;
			MTU4.TGRB = 50;
			break;
			
		case 7:
			//1Oi
			PORTC.PODR.BIT.B5 =0 ;//Forward
			PORTC.PODR.BIT.B6 =0 ;//Forward
			MTU3.TGRC = 6297;
			MTU4.TGRC = 6297;
			MTU3.TGRB = 50;
			MTU4.TGRB = 50;
			break;
			
		case 8:
			//1b~
			PORTC.PODR.BIT.B5 =0 ;//Forward
			PORTC.PODR.BIT.B6 =0 ;//Forward
			MTU3.TGRC = 6297;
			MTU4.TGRC = 6297;
			MTU3.TGRB = 6297;
			MTU4.TGRB = 6297;
			break;
			
		case 9:
			//[^p[It
			PORT1.PODR.BIT.B5=0;	//Motor Power Off
			break;
			
		default:
			break;
			
	}
    }

    if(timer < 500){
        if( timer/50 > duty ){
            PORTB.PODR.BIT.B0=1;
        }else{
            PORTB.PODR.BIT.B0=0;
        }
    }else{
        if( (timer-500)/50 > duty ){
            PORTB.PODR.BIT.B0=0;
        }else{
            PORTB.PODR.BIT.B0=1;
        }
    }
    
    if((timer+125) < 500){
        if( (timer+125)/50 > duty ){
            PORTA.PODR.BIT.B6=1;
        }else{
            PORTA.PODR.BIT.B6=0;
        }
    }else{
        if( (timer-375)/50 > duty ){
            PORTA.PODR.BIT.B6=0;
        }else{
            PORTA.PODR.BIT.B6=1;
        }
    }
    
    if((timer+250) < 500){
        if( (timer%250)/50 > duty ){
            PORTA.PODR.BIT.B4=1;
        }else{
            PORTA.PODR.BIT.B4=0;
        }
    }else{
        if( (timer-250)/50 > duty ){
            PORTA.PODR.BIT.B4=0;
        }else{
            PORTA.PODR.BIT.B4=1;
        }
    }	    

    if((timer+375) < 500){
        if( (timer+375)/50 > duty ){
            PORTA.PODR.BIT.B0=1;
        }else{
            PORTA.PODR.BIT.B0=0;
        }
    }else{
        if( (timer-125)/50 > duty ){
            PORTA.PODR.BIT.B0=0;
        }else{
            PORTA.PODR.BIT.B0=1;
        }
    }	    
    
}
    
void main(void)
{
// clock setting
	SYSTEM.PRCR.WORD   = 0xa50b;	//NbN\[XI̕ی̉
	SYSTEM.PLLCR.WORD  = 0x0F00;	// PLL {~16 1 (12.000MHz * 16 = 192MHz)
	SYSTEM.PLLCR2.BYTE = 0x00;	// PLL ENABLE */
	SYSTEM.SCKCR.LONG  = 0x21C21211;//FCK1/4 ICK1/2 BCLK~ SDCLK~ BCK1/4 PCLKA1/2 PCLKB1/4
	SYSTEM.SCKCR2.WORD = 0x0032;	// UCLK1/4 IEBCK1/4
	SYSTEM.BCKCR.BYTE  = 0x01;	// BCLK = 1/2
	SYSTEM.SCKCR3.WORD = 0x0400;	//PLLHI
// IO setting
	PORTA.PDR.BIT.B6 = 1;//LED0
	PORTB.PDR.BIT.B0 = 1;//LED1
	PORTA.PDR.BIT.B4 = 1;//LED2
	PORTA.PDR.BIT.B0 = 1;//LED3
	PORT1.PDR.BIT.B5 = 1;//motor Enable
	//PORT1.PODR.BIT.B5=0;	//Motor Power Off
	PORT1.PDR.BIT.B5 = 1;//motor Enable
	PORTC.PDR.BIT.B5 = 1;//Rmotor CW/CCW
	PORTC.PDR.BIT.B6 = 1;//Lmotor CW/CCW
//port select
	MPC.PWPR.BIT.B0WI=0;
	MPC.PWPR.BIT.PFSWE=1;
	MPC.PB3PFS.BIT.PSEL=1;	//MTIOC0A buzzer
	MPC.P17PFS.BIT.PSEL=1;	//MTIOC3A Rmotor PWM for clock
	MPC.PE2PFS.BIT.PSEL=1;	//MTIOC4A Lmotor PWM for clock
	MPC.PWPR.BYTE=0x80;
	PORTB.PMR.BIT.B3=1;		//SP PWM
	PORT1.PMR.BIT.B7=1;		//EPWM
	PORTE.PMR.BIT.B2=1;		//PWM
//MTU setting
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP(MTU) = 0;			//MTUW[ON
  	 SYSTEM.PRCR.WORD = 0xA500;	
	MTU.TSTR.BYTE=0;		//^C}Xgbv
	//E[^pMTUݒ
	MTU3.TCR.BIT.TPSC=2;	//PCLK/16 3MHz
	MTU3.TCR.BIT.CCLR=1;	//PWM TGRÃRyA}b`TCNTNA
	MTU3.TIORH.BIT.IOA=2;	//o0yA}b`1o
	MTU3.TIORH.BIT.IOB=1;	//o0RyA}b`0o
	MTU3.TGRA = 6297;	//3000000/((180/0.377) - 1) = 6297
	MTU3.TGRB = 50;
	MTU3.TGRC = 6297;
	MTU3.TMDR.BIT.MD=2;		//PWM1
	MTU3.TMDR.BIT.BFA = 1;	//obt@[[hɐݒ
	MTU3.TIER.BIT.TGIEB = 1;//GRARyA}b`ł̊荞݋
	IEN(MTU3,TGIB3) = 1;	//荞ݗv 
	IPR(MTU3,TGIB3) = 13;	//荞ݗDx_ɐݒ
	IR(MTU3,TGIB3)=0;		//荞݃Xe[^tONA
	//[^pMTUݒ
	MTU.TOER.BIT.OE4A=1;	//MTUo͒[qo͋
	MTU4.TCR.BIT.TPSC=2;	//PCLK/16 3MHz
	MTU4.TCR.BIT.CCLR=1;	//PWM TGRÃRyA}b`TCNTNA
	MTU4.TIORH.BIT.IOA=2;	//o0yA}b`1o
	MTU4.TIORH.BIT.IOB=1;	//o0RyA}b`0o
	MTU4.TGRA = 6297;
	MTU4.TGRB = 50;
	MTU4.TGRC = 6297;
	MTU4.TMDR.BIT.MD=2;		//PWM1
	MTU4.TMDR.BIT.BFA = 1;	//obt@[[hɐݒ
	MTU4.TIER.BIT.TGIEB = 1;//GRARyA}b`ł̊荞݋
	IEN(MTU4,TGIB4) = 1;	//荞ݗv 
	IPR(MTU4,TGIB4) = 12;	//荞ݗDx_ɐݒ
	IR(MTU4,TGIB4)=0;		//荞݃Xe[^tONA
	
	
	//PORT1.PODR.BIT.B5=0;	//Motor Power Off
	PORT1.PODR.BIT.B5=1;
	PORTC.PODR.BIT.B5 =0 ;//Forward
	PORTC.PODR.BIT.B6 =0 ;//Forward

	MTU.TSTR.BIT.CST0 = 1;	//^C}X^[g
	MTU.TSTR.BIT.CST3 = 1;	//^C}X^[g
	MTU.TSTR.BIT.CST4 = 1;	//^C}X^[g
	
//CMT setting
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP(CMT0) = 0;
	SYSTEM.PRCR.WORD = 0xA500;	
	//CMT0͐䊄荞ݗp^C}ƂĎgp
	CMT0.CMCR.BIT.CKS=1;	// PCLK/32 1.5MHz
	CMT0.CMCR.BIT.CMIE=1;	//荞݂
	CMT0.CMCNT=0;		//JE^[̃NA
	CMT0.CMCOR=1500-1;	//1kHz
	IEN(CMT0,CMI0) = 1;	//荞ݗv 
	IPR(CMT0,CMI0) = 15;	//荞ݗDx 15ō
	IR(CMT0,CMI0)=0;	//荞݃Xe[^tONA
	CMT.CMSTR0.BIT.STR0=1;	//JEgX^[g
	
	while(1);
}

#ifdef __cplusplus
void abort(void)
{

}
#endif
